/* ----------------------------------------------
	Nyisztor Kroly
	Shaderprogramozs
	Grafika s jtkfejleszts DirectX-szel II
	
	FX fjl	: VertexColors.fx
	
	Lsd	: 11.4. Sznes geometria megjelentse
			  305. oldal
------------------------------------------------- */
// World*View*Proj mtrix
uniform extern float4x4	gWorldViewProjection;

// vertexrnyal eredmnyt trol struktra
struct VS_OUTPUT
{
    float4 PositionProj : POSITION0;
	float4 VertexColor	: COLOR0;
};
// cscspont rnyal
VS_OUTPUT vs_main(float3 posLocal_in : POSITION0, 
				  float4 color_in : COLOR0)
{
    // eredmny struktra kinullzsa
	VS_OUTPUT outVS = (VS_OUTPUT)0;
	
	// transzformci vgrehajtsa
	outVS.PositionProj = mul(float4(posLocal_in, 1.0f), gWorldViewProjection);
	// vertex szn belltsa
	outVS.VertexColor = color_in;
	 
	// a kitlttt struktra visszatrtse
    return outVS;
}
// kppont rnyal
float4 ps_main( float4 color_in : COLOR0 ) : COLOR
{
	// a raszterizci sorn interpollt sznt rvnyesti a kppontra 	
    return color_in;
}

technique WireframeColorTech
{
    pass P0
    {
		// LLAPOTOK
		// drtvzas
		FillMode = Wireframe; 
		ShadeMode = Gouraud;

        // a P0 lps cscspont- s kppontrnyalja
        vertexShader = compile vs_2_0 vs_main();
        pixelShader  = compile ps_2_0 ps_main();
    }
}
technique FilledColorTech
{
    pass P0
    {
		// LLAPOTOK
		// kitlttt
		FillMode = Solid;
		//ShadeMode = Flat;
        // a P0 lps cscspont- s kppontrnyalja
        vertexShader = compile vs_2_0 vs_main();
        pixelShader  = compile ps_2_0 ps_main();
    }
}
