/* ----------------------------------------------
	Nyisztor Kroly
	Shaderprogramozs
	Grafika s jtkfejleszts DirectX-szel II
	
	FX fjl	: Simple.fx
	Lers	: egyszeru rnyal, a geometrit 
			  huzalvzasan jelenti meg 
	Lsd	: 11.2 fejezet "Az els effekt - Huzalvzas modell megjelentse"
			  299. oldal
------------------------------------------------- */
// World*View*Proj mtrix
uniform extern float4x4 gWorldViewProjection; 
// vertexrnyal eredmnyt trol struktra
struct VS_OUTPUT 
{
   float4 Position : POSITION0;
};

// vertexrnyal
VS_OUTPUT vs_main(float3 pos : POSITION0)
{
	// eredmny struktra kinullzsa
	VS_OUTPUT outVS = (VS_OUTPUT)0;
	
	// transzformci vgrehajtsa
	outVS.Position = mul(float4(pos, 1.0f), gWorldViewProjection);
	 
	// a kitlttt struktra visszatrtse
	return outVS;
}

// kppont rnyal
float4 ps_main() : COLOR0
{
    return float4(1.0f, 1.0f, 1.0f, 1.0f);
}

// technika
technique SimpleTech
{
	// lps
	pass P0
    {
		// llapotok
		FillMode = Solid;
		
		// a P0 lps cscspont- s kppontrnyalja
		vertexShader = compile vs_2_0 vs_main(); // VS 2.0
		pixelShader  = compile ps_2_0 ps_main(); // PS 2.0
    }
}
