/* ----------------------------------------------
	Nyisztor Kroly
	Shaderprogramozs
	Grafika s jtkfejleszts DirectX-szel II
	
	FX fjl	: Ambient.fx
	Lers	: Ambiens megvilgtsi modell 
	Lsd	: 11.6.1. "ltalnos httrmegvilgts"
			  323. oldal
------------------------------------------------- */
// World*View*Proj mtrix
uniform extern float4x4	gWorldViewProjection;
// anyag ambiens szne
uniform extern float4 gAmbientMaterialColor;
// fny ambiens szne
uniform extern float4 gAmbientLightColor;
	
struct VS_OUTPUT
{
    float4 PositionProj : POSITION0;
	float4 VertexColor	: COLOR0;
};
// cscspont rnyal
VS_OUTPUT vs_main(float3 posLocal_in : POSITION0 )
{
    // eredmny struktra kinullzsa
	VS_OUTPUT outVS = (VS_OUTPUT)0;
	
	// transzformci vgrehajtsa
	outVS.PositionProj = mul(float4(posLocal_in, 1.0f), gWorldViewProjection);
	
	outVS.VertexColor = gAmbientMaterialColor * gAmbientLightColor;
	// a kitlttt struktra visszatrtse
    return outVS;
}
// kppont rnyal
float4 ps_main(float4 color_in : COLOR0) : COLOR
{
	return color_in;
}

technique AmbientTech
{
    pass P0
    {
		// LLAPOTOK
		FillMode = Solid;

        // a P0 lps cscspont- s kppontrnyalja
        vertexShader = compile vs_2_0 vs_main();
        pixelShader  = compile ps_2_0 ps_main();
    }
}
